package com.telenav;

import com.googlecode.javacpp.*;
import com.googlecode.javacpp.annotation.*;

@Platform(include = "LegacyLibrary.h",link="JavaCPPFiles")
@Namespace("LegacyLibrary")
public class LegacyLibrary {
	public static class LegacyClass extends Pointer {
		static {
			Loader.load();
		}

		public LegacyClass() {
			allocate();
		}

		private native void allocate();

		// to call the getter and setter functions
		public native @StdString
		String get_property();

		public native void set_property(String property);
	}

	public static void main(String[] args) {
		// Pointer objects allocated in Java get deallocated once they become
		// unreachable,
		// but C++ destructors can still be called in a timely fashion with
		// Pointer.deallocate()
		LegacyClass l = new LegacyClass();
		l.set_property("Hello World!aaa");
		System.out.println(l.get_property());
	}
}